import {
  ModalService, Modal, Form, Select, IButtonEvent,
} from '@zeedhi/common';
import {
  Loader, Metadata, IEventParam,
} from '@zeedhi/core';
  
export class Pla01300PercentualReceitaController {
  private utilities = Loader.getInstance('Utilities');
  
  public modalPercentualReceita!: Modal;
    
  private async createModalPercentualReceita() {
    this.modalPercentualReceita = await ModalService.createFromJson(
      'planejamento//modals/pla01303_utilizacao_produtos', true,
    );
  }
      
  public closeModalPercentualReceita() {
    this.modalPercentualReceita.hide();
  }
      
  public openModalPercentualReceita() {
    if (!this.modalPercentualReceita) {
      this.createModalPercentualReceita().then(() => {
        this.modalPercentualReceita.show();
      });
    } else {
      this.modalPercentualReceita.show();
    }
  }

  public fullscreen({ component }: IButtonEvent) {
    this.modalPercentualReceita.fullscreen = !this.modalPercentualReceita.fullscreen;
    component.iconName = (this.modalPercentualReceita.fullscreen) ? 'mdi-fullscreen-exit' : 'mdi-fullscreen';
  }

  public setFilterService({ component }: IEventParam<Select>) {
    const form: Form = Metadata.getInstance('formAcoes');
    const row = form.value;
    const conditions = [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: row.UNIDADE,
      },
      {
        name: 'IDTIPOSERV',
        operator: '=',
        value: localStorage.getItem('PRODUCT_ID') === '4875' ? '' : 'N',
      },
    ];
    component.datasource.filter = conditions;
    component.datasource.get();
  }

  public setFilterServiceDest({ component }: IEventParam<Select>) {
    const form: Form = Metadata.getInstance('formFiltroRevAuto2');
    const row = form.value;
    const conditions = [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: row.UNIDADE,
      },
      {
        name: 'IDTIPOSERV',
        operator: '=',
        value: localStorage.getItem('PRODUCT_ID') === '4875' ? '' : 'N',
      },
    ];
    component.datasource.filter = conditions;
    component.datasource.get();
  }
}
